<?php
/**
 * @package		we_cloudflare 1.5/1.6/1.7/2.5/3.0/3.1
 * @type		Plugin (System)
 * @filename	we_cloudflare.php
 * @folder		<root>/plugins/system/ultimatesitetools
 * @version		1.0
 * @modified	13 May 2013
 * @author		Web-expert.gr / Stergios Zgouletas
 * @website		http://www.web-expert.gr
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 * 
 * @copyright (C) 2011 Web-expert.gr
 *
 * This program can be used under the terms of the GNU General Public License
 * as published by the Free Software Foundation, either version 3 of the License.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
**/

defined('_JEXEC') or die('Restricted access');
if(!defined('CLOUDFLARE_VERSION')) define('CLOUDFLARE_VERSION', '1.0');
jimport( 'joomla.plugin.plugin' );

class plgSystemWe_cloudflare extends JPlugin
{
	public function __construct(&$subject, $config)
	{
		parent::__construct($subject, $config);
	}

	function onAfterInitialise() {
		$app =JFactory::getApplication();

		//Check if CloudFlare is working
		$is_cf = (isset($_SERVER["HTTP_CF_CONNECTING_IP"]))? TRUE: FALSE;
		JResponse::setHeader('CF-IP-Status',$is_cf,true);
		if(!$is_cf) return;
		
		//Include IP Check Functions
		$file=dirname(__FILE__).'/ip_in_range.php';
		if(!file_exists($file)) return ;
		require_once($file);
		
		//Redirect to www. - CloudFlare Proxy works only over WWW.
		if(!$app->isAdmin() && strpos($_SERVER["HTTP_HOST"], "www.")===false){
			$protocol=(isset($_SERVER['HTTPS']) && !empty($_SERVER['HTTPS']))?"https":"http";
			@header("HTTP/1.1 301 Moved Permanently");
			JResponse::setHeader('Location',$protocol."://www.".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'],true);
			exit();		
		}
		
		//IPV4
		if (strpos($_SERVER["REMOTE_ADDR"], ":") === FALSE) {
			$cf_ip_ranges = array("204.93.240.0/24", "204.93.177.0/24", "199.27.128.0/21", "173.245.48.0/20", "103.22.200.0/22", "141.101.64.0/18", "108.162.192.0/18","190.93.240.1/20","188.114.96.0/20", "198.41.128.0/17");
			foreach ($cf_ip_ranges as $range) {
				if (ipv4_in_range($_SERVER["REMOTE_ADDR"], $range)) {
					if ($_SERVER["HTTP_CF_CONNECTING_IP"]) {
						$_SERVER["REMOTE_ADDR"] = $_SERVER["HTTP_CF_CONNECTING_IP"];
						JRequest::setVar('REMOTE_ADDR',$_SERVER["HTTP_CF_CONNECTING_IP"],'SERVER',true); //RealIP
					}
					break;
				}
			}        
		} else {
			$cf_ip_ranges = array("2400:cb00::/32", "2606:4700::/32", "2803:f800::/32");
			$ipv6 = get_ipv6_full($_SERVER["REMOTE_ADDR"]); //IPV6
			foreach ($cf_ip_ranges as $range) {
				if (ipv6_in_range($ipv6, $range)) {
					if ($_SERVER["HTTP_CF_CONNECTING_IP"]) {
						$_SERVER["REMOTE_ADDR"] = $_SERVER["HTTP_CF_CONNECTING_IP"];
						JRequest::setVar('REMOTE_ADDR',$_SERVER["HTTP_CF_CONNECTING_IP"],'SERVER',true); //RealIP
					}
					break;
				}
			}
		}
		JResponse::setHeader('X-CF-Powered-By','Web-expert J! CloudFlare Plg v.'. CLOUDFLARE_VERSION,true);
		// Makes Joomla! Varnish-friendly
		// For more check out: https://snipt.net/fevangelou/the-perfect-varnish-configuration-for-joomla-websites/
		$user = JFactory::getUser();
		$status=(!$user->guest)?'True':'False';
		JResponse::setHeader('X-Logged-In', $status, true);//Set Header with User Status . Usefull for Varnish
	}
}